week9- Dynamic Programming-NO.377. Combination Sum IV

来源:互联网 发布:身份证查电话号码软件 编辑:程序博客网 时间:2024/06/08 01:57

题目

  • Total Accepted: 31882
  • Total Submissions: 76495
  • Difficulty: Medium
  • Contributor: LeetCode

Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.

Example:

nums = [1, 2, 3]target = 4The possible combination ways are:(1, 1, 1, 1)(1, 1, 2)(1, 2, 1)(1, 3)(2, 1, 1)(2, 2)(3, 1)Note that different sequences are counted as different combinations.Therefore the output is 7.
https://leetcode.com/problems/combination-sum-iv/#/description

思路

题目给定一个正整数数组,以及一个目标值,希望找到能由数组中的元素可重复地相加得到目标值的方案数。

使用动态规划的思想,设s【i】表示能由数组中元素可重复相加得到i的方案个数,nums【j】表示数组中第j个元素。当i=0,1...n - 1的s【i】都求得时,则s【n】=∑ s【n - nums[j]】(nums[j] <= n)。

源程序 

class Solution {public:    int combinationSum4(vector<int>& nums, int target) {        if(nums.size() == 0)            return 0;        int s[100000],i,j,count;        s[0] = 1;        for(i = 1;i <= target;i ++){            count = 0;            for(j = 0;j < nums.size();j ++){                if(nums[j] <= i){                    count += s[i - nums[j]];                }            }            s[i] = count;        }        return s[target];    }};


0 0
原创粉丝点击